/*******************************************************************************
 *
 * blueMarine - open source photo workflow
 * =======================================
 *
 * Copyright (C) 2003-2010 by Fabrizio Giudici
 * Project home page: http://bluemarine.tidalwave.it
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *******************************************************************************
 *
 * $Id: SemanticPersistence.java,v 6b7898539fc3 2010/03/14 17:43:42 fabrizio $
 *
 ******************************************************************************/
package it.tidalwave.semantic.persistence;

import java.util.Set;
import javax.annotation.Nonnull;
import org.openrdf.repository.Repository;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: SemanticPersistence.java,v 6b7898539fc3 2010/03/14 17:43:42 fabrizio $
 *
 ******************************************************************************/
public interface SemanticPersistence
  {
    /***************************************************************************
     *
     *
     **************************************************************************/
    @Nonnull
    public Repository createRepository (@Nonnull final String name);

    /***************************************************************************
     *
     *
     **************************************************************************/
    public void removeRepository (@Nonnull final Repository context);

    /***************************************************************************
     *
     *
     **************************************************************************/
    @Nonnull
    public Set<String> getRepositoryNames();

    /***************************************************************************
     *
     *
     **************************************************************************/
    @Nonnull
    public Repository findRepositoryByName (@Nonnull final String name)
      throws NoSuchContextException;
  }
