/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.tidalwave.semantic.persistence;

import javax.annotation.Nonnull;
import org.openide.util.lookup.ServiceProvider;
import it.tidalwave.aspect.Aspect;
import it.tidalwave.aspect.AspectFactory;
import it.tidalwave.netbeans.util.Locator;
import it.tidalwave.semantic.persistence.impl.ElmoTransactionalAspect;
import org.openrdf.elmo.ElmoModule;
import org.openrdf.elmo.sesame.SesameManagerFactory;
import org.openrdf.repository.Repository;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: TransactionalAspectFactory.java,v 1c263a6d8ac9 2010/02/14 00:23:33 fabrizio $
 *
 **********************************************************************************************************************/
@ServiceProvider(service=TransactionalAspectFactory.class)
public class TransactionalAspectFactory implements AspectFactory
  {
    private SesameManagerFactory smf;

    private ElmoModule elmoModule;

    public TransactionalAspectFactory()
      {
        try
          {
            final SemanticPersistence semanticPersistence = Locator.find(SemanticPersistence.class);
            final Repository repository = semanticPersistence.findRepositoryByName("DEFAULT");
            elmoModule = new ElmoModule();
            smf = new SesameManagerFactory(elmoModule, repository);
          }
        catch (NoSuchContextException e)
          {
            throw new RuntimeException(e);
          }
      }

    @Override @Nonnull
    public Aspect createAspect()
      {
        return new ElmoTransactionalAspect(smf);
      }
  }
